using System;
using System.Drawing;
using System.IO;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Text;
using Visio = Microsoft.Office.Interop.Visio;

namespace vy4500u_DotNET
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
  public class Form1 : System.Windows.Forms.Form {
    private System.Windows.Forms.Panel pa_Top;
    private System.Windows.Forms.Panel pa_Main;
    private System.Windows.Forms.Button bt_TidyWindows;
    private System.Windows.Forms.MainMenu mainMenu1;
    private System.Windows.Forms.MenuItem mh_File;
    private System.Windows.Forms.MenuItem mi_New;
    private System.Windows.Forms.MenuItem mi_Open;
    private System.Windows.Forms.MenuItem mi_Save;
    private System.Windows.Forms.MenuItem menuItem5;
    private System.Windows.Forms.MenuItem mi_Quit;

    private System.Windows.Forms.MenuItem mi_Clear;
    private System.Windows.Forms.OpenFileDialog openFileDialog1;
    private System.Windows.Forms.SaveFileDialog saveFileDialog1;
    private System.Windows.Forms.MenuItem mi_SaveAs;
    private System.Windows.Forms.Panel pa_LowerLeft;
    private System.Windows.Forms.Panel pa_LowerRight;
    private AxMicrosoft.Office.Interop.VisOcx.AxDrawingControl VDC1;
    private System.Windows.Forms.Splitter splitter1;
    private System.Windows.Forms.ListBox listBox1;
    private System.Windows.Forms.Button bt_PopulateList;
    private System.Windows.Forms.Button bt_AddVDXShapesToList;

    /// <summary>
    /// Required designer variable.
    /// </summary>
    private System.ComponentModel.Container components = null;

    //---------------------------------------
    // Manually-added variables
    //---------------------------------------
    private string HomeDir;
    private const string StartDocName = "MyStartDoc.vdx";
    // "F:\Proj_V11DSP\_DistribPrep\CSharp\vy4500u_DotNET\vy4500u_DotNET\bin\Debug\MyStartDoc.vdx"
    private string LastOpenedDoc;
    private Visio.Document StencilDoc;
    private Random MyRandom = new Random();
    private int MouseDownX, MouseDownY, DragState=0;

    private const string MinimalSampleVDXShape_FileName = "MinimalSampleVDXShape.txt";
    private const string AnotherSampleVDXShape_FileName = "AnotherSampleVDXShape.txt";
    private const string MinimalSampleVDXShape_ListName = "zzz Minimal Sample VDX Shape";
    private const string AnotherSampleVDXShape_ListName = "zzz Another Sample VDX Shape";
    private const string cfVisioVDXShape = "VISIO XML Shapes";
    private MemoryStream MinimalSampleVDXShape_MemStr, AnotherSampleVDXShape_MemStr;
    private Byte[] MinimalSampleVDXShape_Bytes, AnotherSampleVDXShape_Bytes;

    public Form1() {
      //
      // Required for Windows Form Designer support
      //
      InitializeComponent();

      //
      // TODO: Add any constructor code after InitializeComponent call
      //
    }

    /// <summary>
    /// Clean up any resources being used.
    /// </summary>
    /// 
    protected override void Dispose( bool disposing ) {
      if( disposing ) {
        if (components != null) {
          components.Dispose();
        }
      }
      base.Dispose( disposing );
    }

    #region Windows Form Designer generated code
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    private void InitializeComponent() {
      System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
      this.pa_Top = new System.Windows.Forms.Panel();
      this.bt_AddVDXShapesToList = new System.Windows.Forms.Button();
      this.bt_PopulateList = new System.Windows.Forms.Button();
      this.bt_TidyWindows = new System.Windows.Forms.Button();
      this.pa_Main = new System.Windows.Forms.Panel();
      this.splitter1 = new System.Windows.Forms.Splitter();
      this.pa_LowerRight = new System.Windows.Forms.Panel();
      this.VDC1 = new AxMicrosoft.Office.Interop.VisOcx.AxDrawingControl();
      this.pa_LowerLeft = new System.Windows.Forms.Panel();
      this.listBox1 = new System.Windows.Forms.ListBox();
      this.mainMenu1 = new System.Windows.Forms.MainMenu();
      this.mh_File = new System.Windows.Forms.MenuItem();
      this.mi_New = new System.Windows.Forms.MenuItem();
      this.mi_Clear = new System.Windows.Forms.MenuItem();
      this.mi_Open = new System.Windows.Forms.MenuItem();
      this.mi_Save = new System.Windows.Forms.MenuItem();
      this.mi_SaveAs = new System.Windows.Forms.MenuItem();
      this.menuItem5 = new System.Windows.Forms.MenuItem();
      this.mi_Quit = new System.Windows.Forms.MenuItem();
      this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
      this.saveFileDialog1 = new System.Windows.Forms.SaveFileDialog();
      this.pa_Top.SuspendLayout();
      this.pa_Main.SuspendLayout();
      this.pa_LowerRight.SuspendLayout();
      ((System.ComponentModel.ISupportInitialize)(this.VDC1)).BeginInit();
      this.pa_LowerLeft.SuspendLayout();
      this.SuspendLayout();
      // 
      // pa_Top
      // 
      this.pa_Top.Controls.Add(this.bt_AddVDXShapesToList);
      this.pa_Top.Controls.Add(this.bt_PopulateList);
      this.pa_Top.Controls.Add(this.bt_TidyWindows);
      this.pa_Top.Dock = System.Windows.Forms.DockStyle.Top;
      this.pa_Top.Location = new System.Drawing.Point(0, 0);
      this.pa_Top.Name = "pa_Top";
      this.pa_Top.Size = new System.Drawing.Size(824, 72);
      this.pa_Top.TabIndex = 0;
      // 
      // bt_AddVDXShapesToList
      // 
      this.bt_AddVDXShapesToList.Location = new System.Drawing.Point(96, 16);
      this.bt_AddVDXShapesToList.Name = "bt_AddVDXShapesToList";
      this.bt_AddVDXShapesToList.Size = new System.Drawing.Size(96, 40);
      this.bt_AddVDXShapesToList.TabIndex = 4;
      this.bt_AddVDXShapesToList.Text = "Add VDX Shapes to List";
      this.bt_AddVDXShapesToList.Click += new System.EventHandler(this.bt_AddVDXShapesToList_Click);
      // 
      // bt_PopulateList
      // 
      this.bt_PopulateList.Location = new System.Drawing.Point(16, 16);
      this.bt_PopulateList.Name = "bt_PopulateList";
      this.bt_PopulateList.Size = new System.Drawing.Size(64, 40);
      this.bt_PopulateList.TabIndex = 3;
      this.bt_PopulateList.Text = "Populate List";
      this.bt_PopulateList.Click += new System.EventHandler(this.bt_PopulateList_Click);
      // 
      // bt_TidyWindows
      // 
      this.bt_TidyWindows.Location = new System.Drawing.Point(216, 16);
      this.bt_TidyWindows.Name = "bt_TidyWindows";
      this.bt_TidyWindows.Size = new System.Drawing.Size(72, 40);
      this.bt_TidyWindows.TabIndex = 0;
      this.bt_TidyWindows.Text = "Tidy Windows";
      this.bt_TidyWindows.Click += new System.EventHandler(this.bt_TidyWindows_Click);
      // 
      // pa_Main
      // 
      this.pa_Main.Controls.Add(this.splitter1);
      this.pa_Main.Controls.Add(this.pa_LowerRight);
      this.pa_Main.Controls.Add(this.pa_LowerLeft);
      this.pa_Main.Dock = System.Windows.Forms.DockStyle.Fill;
      this.pa_Main.Location = new System.Drawing.Point(0, 72);
      this.pa_Main.Name = "pa_Main";
      this.pa_Main.Size = new System.Drawing.Size(824, 446);
      this.pa_Main.TabIndex = 1;
      // 
      // splitter1
      // 
      this.splitter1.Location = new System.Drawing.Point(216, 0);
      this.splitter1.Name = "splitter1";
      this.splitter1.Size = new System.Drawing.Size(3, 446);
      this.splitter1.TabIndex = 3;
      this.splitter1.TabStop = false;
      // 
      // pa_LowerRight
      // 
      this.pa_LowerRight.Controls.Add(this.VDC1);
      this.pa_LowerRight.Dock = System.Windows.Forms.DockStyle.Fill;
      this.pa_LowerRight.Location = new System.Drawing.Point(216, 0);
      this.pa_LowerRight.Name = "pa_LowerRight";
      this.pa_LowerRight.Size = new System.Drawing.Size(608, 446);
      this.pa_LowerRight.TabIndex = 2;
      // 
      // VDC1
      // 
      this.VDC1.ContainingControl = this;
      this.VDC1.Dock = System.Windows.Forms.DockStyle.Fill;
      this.VDC1.Enabled = true;
      this.VDC1.Location = new System.Drawing.Point(0, 0);
      this.VDC1.Name = "VDC1";
      this.VDC1.OcxState = ((System.Windows.Forms.AxHost.State)(resources.GetObject("VDC1.OcxState")));
      this.VDC1.Size = new System.Drawing.Size(608, 446);
      this.VDC1.TabIndex = 1;
      // 
      // pa_LowerLeft
      // 
      this.pa_LowerLeft.Controls.Add(this.listBox1);
      this.pa_LowerLeft.Dock = System.Windows.Forms.DockStyle.Left;
      this.pa_LowerLeft.Location = new System.Drawing.Point(0, 0);
      this.pa_LowerLeft.Name = "pa_LowerLeft";
      this.pa_LowerLeft.Size = new System.Drawing.Size(216, 446);
      this.pa_LowerLeft.TabIndex = 1;
      // 
      // listBox1
      // 
      this.listBox1.Dock = System.Windows.Forms.DockStyle.Fill;
      this.listBox1.Location = new System.Drawing.Point(0, 0);
      this.listBox1.Name = "listBox1";
      this.listBox1.Size = new System.Drawing.Size(216, 446);
      this.listBox1.TabIndex = 0;
      this.listBox1.MouseDown += new System.Windows.Forms.MouseEventHandler(this.listBox1_MouseDown);
      this.listBox1.MouseUp += new System.Windows.Forms.MouseEventHandler(this.listBox1_MouseUp);
      this.listBox1.MouseMove += new System.Windows.Forms.MouseEventHandler(this.listBox1_MouseMove);
      // 
      // mainMenu1
      // 
      this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                              this.mh_File});
      // 
      // mh_File
      // 
      this.mh_File.Index = 0;
      this.mh_File.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                            this.mi_New,
                                                                            this.mi_Clear,
                                                                            this.mi_Open,
                                                                            this.mi_Save,
                                                                            this.mi_SaveAs,
                                                                            this.menuItem5,
                                                                            this.mi_Quit});
      this.mh_File.Text = "&File";
      // 
      // mi_New
      // 
      this.mi_New.Index = 0;
      this.mi_New.Text = "&New (Reload Startup Doc)";
      this.mi_New.Click += new System.EventHandler(this.mi_New_Click);
      // 
      // mi_Clear
      // 
      this.mi_Clear.Index = 1;
      this.mi_Clear.Text = "&Clear Doc";
      this.mi_Clear.Click += new System.EventHandler(this.mi_Clear_Click);
      // 
      // mi_Open
      // 
      this.mi_Open.Index = 2;
      this.mi_Open.Text = "&Open...";
      this.mi_Open.Click += new System.EventHandler(this.mi_Open_Click);
      // 
      // mi_Save
      // 
      this.mi_Save.Index = 3;
      this.mi_Save.Text = "&Save...";
      this.mi_Save.Click += new System.EventHandler(this.mi_Save_Click);
      // 
      // mi_SaveAs
      // 
      this.mi_SaveAs.Index = 4;
      this.mi_SaveAs.Text = "Save &As...";
      this.mi_SaveAs.Click += new System.EventHandler(this.mi_SaveAs_Click);
      // 
      // menuItem5
      // 
      this.menuItem5.Index = 5;
      this.menuItem5.Text = "-";
      // 
      // mi_Quit
      // 
      this.mi_Quit.Index = 6;
      this.mi_Quit.Text = "&Quit";
      this.mi_Quit.Click += new System.EventHandler(this.mi_Quit_Click);
      // 
      // openFileDialog1
      // 
      this.openFileDialog1.DefaultExt = "vsd";
      this.openFileDialog1.ShowReadOnly = true;
      // 
      // Form1
      // 
      this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
      this.ClientSize = new System.Drawing.Size(824, 518);
      this.Controls.Add(this.pa_Main);
      this.Controls.Add(this.pa_Top);
      this.Menu = this.mainMenu1;
      this.Name = "Form1";
      this.Text = "Form1";
      this.Load += new System.EventHandler(this.Form1_Load);
      this.pa_Top.ResumeLayout(false);
      this.pa_Main.ResumeLayout(false);
      this.pa_LowerRight.ResumeLayout(false);
      ((System.ComponentModel.ISupportInitialize)(this.VDC1)).EndInit();
      this.pa_LowerLeft.ResumeLayout(false);
      this.ResumeLayout(false);

    }
    #endregion

    /// <summary>
    /// The main entry point for the application.
    /// </summary>
    //---------------------------------
    [STAThread]  static void Main() {
    //---------------------------------
      Application.Run(new Form1());
    }

    //---------------------------------
    private void Form1_Load(object sender, System.EventArgs e) {
    //---------------------------------
      string S = Application.ExecutablePath;
      HomeDir = Path.GetDirectoryName(S);      
      try {
        Doc_ReloadStartupDoc();
      } catch( Exception ex) {
        string msg = "Form1_Load: " + ex.Message;
        MessageBox.Show(msg);
      }
      StencilDoc = null;
    }	

    //---------------------------------
    private void mi_New_Click(object sender, System.EventArgs e)  {    
    //---------------------------------
      try {
        Doc_ReloadStartupDoc();
      } catch( Exception ex) {
        string msg = "mi_New_Click: " + ex.Message;
        MessageBox.Show(msg);
      }
      LastOpenedDoc = "";
    }

    //---------------------------------
    private void mi_Clear_Click(object sender, System.EventArgs e) {
    //---------------------------------
      try {
        Doc_Clear();    
      } catch( Exception ex) {
        string msg = "mi_Clear_Click: " + ex.Message;
        MessageBox.Show(msg);
      }
      LastOpenedDoc = "";
    }

    //---------------------------------
    private void mi_Open_Click(object sender, System.EventArgs e) {
      //---------------------------------
      if(openFileDialog1.ShowDialog() == DialogResult.OK) {
        string FilePath = openFileDialog1.FileName;
        try {
          LastOpenedDoc = "";
          VDC1.Src = FilePath;
          LastOpenedDoc = FilePath;
          VDC1.Src = "";    // so filename not saved in Reg?
        } catch(Exception ex) {
          string msg = "mi_Open_Click" + ex.Message;
          MessageBox.Show(msg);
        }
      }
    }

    //---------------------------------
    private void mi_Save_Click(object sender, System.EventArgs e) {
      //---------------------------------
      if (LastOpenedDoc != "") {
        try {
          VDC1.Document.SaveAs(LastOpenedDoc);
        } catch (Exception ex) {
          string msg = "mi_Save_Click" + ex.Message;
          MessageBox.Show(msg);
        }
      } else { // we started with blank doc, so use SaveAs
        mi_SaveAs_Click(null, null);
      }    
    }

    //---------------------------------
    private void mi_SaveAs_Click(object sender, System.EventArgs e) {
    //---------------------------------
      if (saveFileDialog1.ShowDialog() == DialogResult.OK) {
        string FilePath = saveFileDialog1.FileName;
        try {
          VDC1.Document.SaveAs(FilePath);
          LastOpenedDoc = FilePath;
        } catch (Exception ex) {
          string msg = "mi_Save_Click" + ex.Message;
          MessageBox.Show(msg);
        }
      }    
    }

    //---------------------------------
    private void mi_Quit_Click(object sender, System.EventArgs e) {
      //---------------------------------
      Close();
    }

    //---------------------------------
    private void bt_TidyWindows_Click(object sender, System.EventArgs e) {
      //---------------------------------
      KillNonDrawingWindows(null);
    }

    //---------------------------------
    private void KillNonDrawingWindows(Visio.Window  StartWin)   { 
      //---------------------------------
      Visio.Windows AWins;

      if (StartWin != null) {
        try  {
          AWins = StartWin.Windows;
        }
        catch {
          AWins = null;
        }
        Visio.VisWinTypes wintype = (Visio.VisWinTypes) StartWin.Type;
        switch ( wintype ) {
          case Visio.VisWinTypes.visDrawing:
            break;
          case Visio.VisWinTypes.visDrawingAddon:
            break;
          case Visio.VisWinTypes.visPageWin:
            break;
          case Visio.VisWinTypes.visStencil:
            break;
          case Visio.VisWinTypes.visDockedStencilBuiltIn:
            break;
          default:
            StartWin.Visible = false;
            AWins = null;
            break;
        }
      }  else {
        AWins = VDC1.Document.Application.Windows;
      }

      if (AWins != null)  {
        foreach (Visio.Window AWin in AWins) {
          KillNonDrawingWindows(AWin);
        }
      }
    }

    //---------------------------------
    private void Doc_Clear() {
      //---------------------------------
      Visio.Document ADoc = VDC1.Document;

      for (int PageIx1 = ADoc.Pages.Count; PageIx1 > 1; PageIx1--) {
        ADoc.Pages[PageIx1].Delete(0);
      }

      Visio.Page APage = ADoc.Pages[1];

      for (int ShapeIx1 = APage.Shapes.Count; ShapeIx1 > 0; ShapeIx1--) {
        APage.Shapes[ShapeIx1].Delete();
      }
    }

    //---------------------------------
    private void Doc_ReloadStartupDoc() {
      //---------------------------------
      string APath = HomeDir + "\\" + StartDocName;      
      VDC1.Src = APath;
      VDC1.Src = "";
      LastOpenedDoc = "";
    }

    //---------------------------------
    private void bt_PopulateList_Click(object sender, System.EventArgs e) {
    //---------------------------------
      const string BasicStencilName = "Basic_U.vss";
      try {
        try {
          StencilDoc = VDC1.Window.Application.Documents[BasicStencilName];  
        } catch {}

        if (StencilDoc == null) {
          StencilDoc = VDC1.Window.Application.Documents.OpenEx("Basic_U.vss", 
            (short) (Visio.VisOpenSaveArgs.visOpenRO | Visio.VisOpenSaveArgs.visOpenHidden ) );
        }

        listBox1.Items.Clear();

        foreach(Visio.Master AMaster in StencilDoc.Masters) {
          listBox1.Items.Add(AMaster.Name);
        }
        listBox1.Sorted = true;

      } catch( Exception ex) {
        string msg = "bt_PopulateList_Click: " + ex.Message;
        MessageBox.Show(msg);
      }      
    }

    //---------------------------------
    private void listBox1_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e) {
    //---------------------------------
      if (e.Button == MouseButtons.Left) {
        MouseDownX = e.X;
        MouseDownY = e.Y;
        DragState = 1;
      }
    }
    //---------------------------------
    private void listBox1_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e) {
    //---------------------------------
      DragState = 0;
    }

    //---------------------------------
    private void listBox1_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e) {
    //---------------------------------
      if (DragState == 1) {
        if ( (Math.Abs(MouseDownX - e.X) < 4) || (Math.Abs(MouseDownY - e.Y) >= 1) ) {
          // Start a drag operations
          DragState = 0;
          try {
            DataObject ADataObject = null;
            // Must use IndexFromPoint because SelectedItem not yet updated
            int SelectedIx0 = listBox1.IndexFromPoint(MouseDownX, MouseDownY); 
            string MasterName = listBox1.Items[SelectedIx0].ToString();

            // Compose XML Shape data or grab selected Master
            if (MasterName == MinimalSampleVDXShape_ListName) {
              ADataObject = new DataObject();
              ADataObject.SetData(cfVisioVDXShape, MinimalSampleVDXShape_MemStr);
            } else if (MasterName == AnotherSampleVDXShape_ListName) {
              ADataObject = new DataObject();
              ADataObject.SetData(cfVisioVDXShape, AnotherSampleVDXShape_MemStr);
            } else {
              Visio.Master AMaster = StencilDoc.Masters.get_ItemU(MasterName);
              ADataObject = new DataObject(AMaster);
            }
            // Initiate Drag and Drop operation
            DragDropEffects DDE = DoDragDrop(ADataObject, DragDropEffects.Copy);
          } catch {
          }
        }
      }
    }

    //---------------------------------
    private void bt_AddVDXShapesToList_Click(object sender, System.EventArgs e) {
    //---------------------------------
      try {
        string FilePath = HomeDir + "\\" + MinimalSampleVDXShape_FileName;
        FileStream fs               = new FileStream(FilePath, FileMode.Open, FileAccess.Read);
        int len                     = (int) fs.Length;
        MinimalSampleVDXShape_Bytes = new Byte[len];
        int rslt = fs.Read(MinimalSampleVDXShape_Bytes, 0, len);
        fs.Close();
        fs = null;
        listBox1.Items.Add(MinimalSampleVDXShape_ListName);
        MinimalSampleVDXShape_MemStr = new MemoryStream(MinimalSampleVDXShape_Bytes);  

        
        FilePath = HomeDir + "\\" + AnotherSampleVDXShape_FileName;
        fs                          = new FileStream(FilePath, FileMode.Open, FileAccess.Read);
        len                         = (int) fs.Length;
        AnotherSampleVDXShape_Bytes = new Byte[len];
        rslt  = fs.Read(AnotherSampleVDXShape_Bytes, 0, len);
        fs.Close();
        fs = null;
        listBox1.Items.Add(AnotherSampleVDXShape_ListName);
        AnotherSampleVDXShape_MemStr = new MemoryStream(AnotherSampleVDXShape_Bytes);  

      } catch (Exception ex) {
        MessageBox.Show("bt_AddVDXShapesToList_Click: " + ex.Message);
      }
    }
  }    
}
