VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "VBVSL"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

'---------------------------------------------------------------------
' VBVSL class
' This class module provides the COM interface to a VB VSL
' It is written to be generic for any VBVSL, so it can be just copied
' unchanged for any new VBVSL project.
'
' It assumes that there will be an Xxx_Main module that implements the
' various VBVSL_xxx procs called from here. Also, that Xxx_Main exposes
' a glo global object for holding refs to Visio and VVA_Callback
'
' Otherwise, this class mostly just delegates all the traditional
' VSL methods to Xxx_Main BAS module
'
' NOTE: This module needs to know about IVBVSL, so requires that the VB
' project that includes it has a Reference to some type lib which defines
' IVBVSL.  Such a type lib is included in each VBVSL Adapter, so any of
' those could be used. Look in the references list for:
' VBVSL_Types 1.0  [Diagramantics] Visio VSL-to-VB interface defs
'----------------------------------------------------------------------

Implements IVBVSL

'==========================================================
' VSL-level methods
'==========================================================

'------------------------------------
Private Sub Class_Initialize()
'------------------------------------
  VBVSL_Initialize
End Sub

'------------------------------------
Private Sub Class_Terminate()
'------------------------------------
  VBVSL_Terminate
  ForgetExternalObjects
End Sub

'------------------------------------------------------------------------------------
Public Sub IVBVSL_VSLInfo(Descr As String)
'------------------------------------------------------------------------------------
  VBVSL_VSLInfo Descr
End Sub

'------------------------------------------------------------------------------------
Public Function IVBVSL_Load(ByVal InterfaceVersion As Long, _
                            ByVal VVA_Callback As VBVSL_Types.IVVA_Callback _
                            ) As VBVSL_Types.Tvbvsl_ResultCodes
'------------------------------------------------------------------------------------
  VVA_CallbackCheck VVA_Callback
  VisioAppCheck
  IVBVSL_Load = VBVSL_Load(InterfaceVersion)
End Function

'------------------------------------------------------------------------------------
Public Function IVBVSL_Unload() As VBVSL_Types.Tvbvsl_ResultCodes
'------------------------------------------------------------------------------------
  VBVSL_Unload
  ForgetExternalObjects
End Function

'------------------------------------------------------------------------------------
Private Function IVBVSL_EnumAddOns(ByVal SessionId As Long, ByVal VVA_Callback As VBVSL_Types.IVVA_Callback) As VBVSL_Types.Tvbvsl_ResultCodes
'------------------------------------------------------------------------------------
  VVA_CallbackCheck VVA_Callback
  IVBVSL_EnumAddOns = VBVSL_EnumAddOns(SessionId)
End Function

'==========================================================
' AddOn-level methods
'==========================================================

'------------------------------------------------------------------------------------
Public Function IVBVSL_IsAddOnEnabled(ByVal AddOnIx As Long, _
                  ByVal SessionId As Long, _
                  ByVal VVA_Callback As VBVSL_Types.IVVA_Callback _
                  ) As VBVSL_Types.Tvbvsl_ResultCodes
'------------------------------------------------------------------------------------
  VVA_CallbackCheck VVA_Callback
  IVBVSL_IsAddOnEnabled = VBVSL_IsAddOnEnabled(AddOnIx, SessionId)
End Function

'------------------------------------------------------------------------------------
Public Function IVBVSL_Run(ByVal AddOnIx As Long, _
                  ByVal SessionId As Long, _
                  ByVal VVA_Callback As VBVSL_Types.IVVA_Callback, _
                  ByVal Args As String _
                  ) As VBVSL_Types.Tvbvsl_ResultCodes
'------------------------------------------------------------------------------------
  VVA_CallbackCheck VVA_Callback
  VisioAppCheck
  IVBVSL_Run = VBVSL_Run(AddOnIx, SessionId, Args)
End Function

'------------------------------------------------------------------------------------
Public Sub IVBVSL_KillSession(ByVal SessionId As Long)
'------------------------------------------------------------------------------------
  VBVSL_KillSession SessionId
End Sub

'------------------------------------------------------------------------------------
Public Function IVBVSL_Test(ByVal I As Long) As Long
'------------------------------------------------------------------------------------
  IVBVSL_Test = VBVSL_Test(I)
End Function

'========================================================
' Management of references to Visio App and to VVA_Callback
'========================================================

'-------------------------------------------
Private Sub VisioAppCheck()
'-------------------------------------------
  On Error Resume Next
  If glo.VisioApp Is Nothing Then
    Set glo.VisioApp = GetObject(, "Visio.Application")
  End If
End Sub

'-------------------------------------------
Private Sub VVA_CallbackCheck(VVA_Callback As IVVA_Callback)
'-------------------------------------------
 On Error Resume Next
  If glo.VVA_Callback Is Nothing Then
    If VVA_Callback <> glo.VVA_Callback Then
      Set glo.VVA_Callback = VVA_Callback
    End If
  End If
End Sub

'-------------------------------------------
Private Sub ForgetExternalObjects()
'-------------------------------------------
  On Error Resume Next
  Set glo.VVA_Callback = Nothing
  Set glo.VisioApp = Nothing
End Sub
