VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "VBVSL_ArgHandler"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Const MaxArgs = 20

Private Enum TParseState
  ps_None = 1
  ps_InKey
  ps_AfterKey
  Ps_InVal
End Enum

Private fParseState As TParseState
Private fKey As String
Private fItem As String
Private fQuoted As Boolean

Private fKeys(1 To MaxArgs) As String
Private fValues(1 To MaxArgs) As String
Private fArgCount As Integer

Private Sub ParseVarsReset()
  fKey = ""
  fItem = ""
  fParseState = ps_None
  fQuoted = False
End Sub

Private Sub Class_Initialize()
  fArgCount = 0
End Sub

Private Sub Enlist()
' Ignore more than MaxArgs arguments
  If fArgCount < MaxArgs Then
    IncI fArgCount
    fKeys(fArgCount) = fKey
    fValues(fArgCount) = fItem
    ParseVarsReset
  End If
End Sub

'-------------------------------------------------
Public Sub ParseArgs(ByVal ArgStr As String)
'-------------------------------------------------
Dim P As Integer, L As Integer, N As Integer
Dim C As String, NextC As String  ' characters

  fArgCount = 0
  ParseVarsReset
  
  L = Len(ArgStr)
  P = 0
  C = " "
  
  While (P < L)
    IncI P
    C = Mid$(ArgStr, P, 1)
    If P < L Then NextC = Mid$(ArgStr, P + 1, 1) Else NextC = " "
    Select Case fParseState
      Case ps_None
        Select Case C
          Case " ", "/" ' do nothing
          Case Else
            fKey = UCase$(C)
            fParseState = ps_InKey
        End Select
      Case ps_InKey
        Select Case C
          Case " "        ' space after key means no value follows
            Enlist
          Case "="        ' value follows, continue
            fParseState = ps_AfterKey
          Case Else
            fKey = fKey + UCase$(C)
        End Select
      Case ps_AfterKey
        Select Case C
          Case " "       ' do nothing
          Case """"      ' quoted item
            fParseState = Ps_InVal
            fQuoted = True
          Case Else
            fItem = fItem + C
            fParseState = Ps_InVal
            fQuoted = False
        End Select
      Case Ps_InVal
        Select Case C
          Case " "
            If fQuoted Then
              fItem = fItem + C
            Else
              Enlist
            End If
          Case """"
            If fQuoted Then
              Enlist
            Else
              fItem = fItem + C
            End If
          Case Else
            fItem = fItem + C
        End Select
    End Select
  Wend
  If fKey <> "" Then Enlist
End Sub

'--------------------------------------------
Public Function FindIndex(ByVal Key As String) As Integer
'--------------------------------------------
' Returns -1 for not found
Dim N As Integer, U As String
  U = UCase$(Key)
  For N = 1 To fArgCount
    If fKeys(N) = U Then
      FindIndex = N
      GoTo foundit
    End If
  Next N
  FindIndex = -1
foundit:
End Function

'--------------------------------------------
Public Function Keys(ByVal Index As Integer) As String
'--------------------------------------------
' Returns empty if not found
  Keys = ""
  If WithinBounds(Index, 1, fArgCount) Then Keys = fKeys(Index)
End Function

'--------------------------------------------
Public Function Values(ByVal Index As Integer) As String
'--------------------------------------------
' Returns empty if not found
  Values = ""
  If WithinBounds(Index, 1, fArgCount) Then Values = fValues(Index)
End Function

'--------------------------------------------
Public Function FindValue(ByVal Key As String) As String
'--------------------------------------------
Dim Ix As Integer
' Returns empty if not found
  FindValue = ""
  Ix = FindIndex(Key)
  If Ix <> -1 Then FindValue = Values(Ix)
End Function

'--------------------------------------------
Public Function ArgCount() As Integer
'--------------------------------------------
  ArgCount = fArgCount
End Function
