VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "VBVSL_WinAlts_Show"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'---------------------------------------------------------------------
' VBVSL_Winalts_Show
'---------------------------------------------------------------------
Implements IVBVSL_AddOn

Private WithEvents fm_Desktop As Tfm_Desktop
Attribute fm_Desktop.VB_VarHelpID = -1

Private WithEvents fm_MDIChild As Tfm_MDIChild
Attribute fm_MDIChild.VB_VarHelpID = -1

Public WithEvents AncHostWindow As Visio.Window
Attribute AncHostWindow.VB_VarHelpID = -1
Private WithEvents fm_Anchored As Tfm_Anchored
Attribute fm_Anchored.VB_VarHelpID = -1

Public WithEvents StenHostWindow As Visio.Window
Attribute StenHostWindow.VB_VarHelpID = -1
Private WithEvents fm_Stencil As Tfm_Stencil
Attribute fm_Stencil.VB_VarHelpID = -1

Private Sub Class_Initialize()
  ' nothing
End Sub

Private Sub Class_Terminate()
  ' nothing
End Sub


'------------------------------------------------------------------------------------
Private Function IVBVSL_AddOn_AddOnInfo( _
        Attribs As VBVSL_Types.Tvbvsl_AddOnInfo_Attribs, _
        EnableMask As VBVSL_Types.Tvbvsl_AddOnInfo_EnableMask, _
        InvokeOnMask As VBVSL_Types.Tvbvsl_AddOnInfo_InvokeOnMask, _
        NotifyOnMask As VBVSL_Types.Tvbvsl_AddOnInfo_NotifyOnMask, _
        Name As String) As VBVSL_Types.Tvbvsl_ResultCodes
'------------------------------------------------------------------------------------
  Attribs = vbvsl_ATTS_ISACTION
  EnableMask = vbvsl_ENABLEALWAYS
  InvokeOnMask = vbvsl_INVOKE_DEFAULT
  NotifyOnMask = vbvsl_NOTIFY_DEFAULT
  Name = "VBVSL_WinAlts_Show"
  
  IVBVSL_AddOn_AddOnInfo = vbvsl_SUCCESS
End Function

'------------------------------------------------------------------------------------
Private Function IVBVSL_AddOn_IsAddOnEnabled() As VBVSL_Types.Tvbvsl_ResultCodes
'------------------------------------------------------------------------------------
  IVBVSL_AddOn_IsAddOnEnabled = vbvsl_L2V_ENABLED
End Function

'------------------------------------------------------------------------------------
Private Sub IVBVSL_AddOn_KillSession(ByVal SessionId As Long)
'------------------------------------------------------------------------------------
  ' nothing
End Sub

'------------------------------------------------------------------------------------
Private Function IVBVSL_AddOn_Load() As VBVSL_Types.Tvbvsl_ResultCodes
'------------------------------------------------------------------------------------
  ' nothing
  IVBVSL_AddOn_Load = vbvsl_SUCCESS
End Function

'------------------------------------------------------------------------------------
Private Function IVBVSL_AddOn_Run(ByVal SessionId As Long, ByVal ArgStr As String) As VBVSL_Types.Tvbvsl_ResultCodes
'------------------------------------------------------------------------------------
Dim Args As VBVSL_ArgHandler, ACmd As String
' for purposes of this demo, assume that user wants a fresh form
' for each call to this addon.  Delete the old one if it's still around

  IVBVSL_AddOn_Run = vbvsl_SUCCESS
  
  Set Args = New VBVSL_ArgHandler
  Args.ParseArgs ArgStr
  
  ACmd = Args.FindValue("Cmd")
  
  On Error Resume Next
  Select Case UCase(ACmd)
    Case "DESKTOP"
        IVBVSL_AddOn_Run = DesktopFormInit(SessionId)
    Case "MDICHILD"
        IVBVSL_AddOn_Run = MDIFormInit(SessionId)
    Case "ANCHORED"
        IVBVSL_AddOn_Run = AncFormInit(SessionId)
    Case "STENCIL"
        IVBVSL_AddOn_Run = StenFormInit(SessionId)
  End Select

End Function

'------------------------------------------------------------------------------------
Private Function IVBVSL_AddOn_Unload() As VBVSL_Types.Tvbvsl_ResultCodes
'------------------------------------------------------------------------------------
  On Error Resume Next
  
  Unload fm_Desktop
  Unload fm_MDIChild
  Unload fm_Anchored
  Unload fm_Stencil

  Set fm_Desktop = Nothing
  Set fm_MDIChild = Nothing
  Set fm_Anchored = Nothing
  Set fm_Stencil = Nothing

  IVBVSL_AddOn_Unload = vbvsl_SUCCESS
End Function


'=============================================================================
' Desktop Window
'=============================================================================

'--------------------------------------
Private Function DesktopFormInit(ASessionId As Long) As Long
'--------------------------------------
Dim NewOwnerHWnd As Long, StyleBits As Long
Dim TheForm As Tfm_Desktop

  DesktopFormInit = vbvsl_SUCCESS ' default, if not going modeless
  If Not (fm_Desktop Is Nothing) Then GoTo done
  
  Set fm_Desktop = New Tfm_Desktop
  fm_Desktop.Show False
  Set TheForm = fm_Desktop
  
  TheForm.SessionId = ASessionId
  DesktopFormInit = vbvsl_L2V_MODELESS
  
  '-------------------------------------------------
  ' Set new *owner* (not parent, despite name of constant)
  '-------------------------------------------------
  NewOwnerHWnd = glo.VisioApp.WindowHandle32
  SetWindowLong TheForm.HWnd, GWL_HWNDPARENT, NewOwnerHWnd
  
  StyleBits = WS_THICKFRAME Or WS_SYSMENU Or WS_BORDER Or WS_CAPTION _
   Or WS_CLIPCHILDREN Or WS_CLIPSIBLINGS Or WS_VISIBLE
  SetWindowLong& TheForm.HWnd, GWL_Style, StyleBits
  
  StyleBits = 0
  SetWindowLong& TheForm.HWnd, GWL_ExStyle, StyleBits
  JiggleWindow TheForm.HWnd
  
  '-------------------------------------------------
  ' Get us on top
  '-------------------------------------------------
  TheForm.ZOrder 0
  
  TheForm.Move 4000, 4000 ' Twips!
  TheForm.RefreshWinInfo
done:
End Function

'--------------------------------------
Private Sub fm_Desktop_OnQueryUnload()
'--------------------------------------
  Set fm_Desktop = Nothing
End Sub

'=============================================================================
' MDI Window
'=============================================================================
'---------------------------------
Public Function MDIFormInit(ASessionId As Long) As Long
'---------------------------------
Dim HW As Long, StyleBits As Long
Dim TheForm As Tfm_MDIChild

  MDIFormInit = vbvsl_SUCCESS ' default, if not going modeless
  If Not (fm_MDIChild Is Nothing) Then GoTo done
  
  Set fm_MDIChild = New Tfm_MDIChild
  fm_MDIChild.Show False
  Set TheForm = fm_MDIChild
 
  TheForm.SessionId = ASessionId
  MDIFormInit = vbvsl_L2V_MODELESS
  '--------------------------------------------------------
  ' MDI Client window
  '--------------------------------------------------------
  HW = glo.VisioApp.WindowHandle32
  HW = FindChildWindowWithClass(HW, "MDIClient")
 
  StyleBits = WS_CHILD _
           Or WS_THICKFRAME Or WS_SYSMENU Or WS_BORDER Or WS_CAPTION _
           Or WS_CLIPCHILDREN Or WS_CLIPSIBLINGS Or WS_VISIBLE _
           Or WS_MINIMIZEBOX Or WS_MAXIMIZEBOX
  SetWindowLong& TheForm.HWnd, GWL_Style, StyleBits
 
  StyleBits = WS_EX_APPWINDOW
  SetWindowLong& TheForm.HWnd, GWL_ExStyle, StyleBits
 
  JiggleWindow TheForm.HWnd
 
  SetParent TheForm.HWnd, HW
  TheForm.RefreshWinInfo
done:
End Function

'--------------------------------------
Private Sub fm_MDIChild_OnQueryUnload()
'--------------------------------------
  Set fm_MDIChild = Nothing
End Sub

'=============================================================================
' Anchor Window
'=============================================================================
'---------------------------------
Private Function AncFormInit(ASessionId As Long) As Long
'---------------------------------
Dim AWindow As Visio.Window, S As String
Dim NewOwnerHWnd As Long, StyleBits As Long
Dim TheForm As Tfm_Anchored

  AncFormInit = vbvsl_SUCCESS ' default, if not going modeless
  If Not (fm_Anchored Is Nothing) Then GoTo done
  '------------------------------------
  ' Check that there's an ActiveWindow
  '------------------------------------
  On Error Resume Next
  Set AWindow = Nothing
  Set AWindow = glo.VisioApp.ActiveWindow
  On Error GoTo 0
  
  If AWindow Is Nothing Then
    MsgBox "No active window currently", , "Error"
    GoTo done
  End If
  
  '------------------------------------
  ' Set up new form
  '------------------------------------
  Set fm_Anchored = New Tfm_Anchored
  fm_Anchored.Show False
  Set TheForm = fm_Anchored
  TheForm.SessionId = ASessionId
  AncFormInit = vbvsl_L2V_MODELESS
 
  StyleBits = WS_CHILD Or WS_VISIBLE
  SetWindowLong& TheForm.HWnd, GWL_Style, StyleBits
   
  Set AncHostWindow = Nothing
  On Error Resume Next
  Set AncHostWindow = AWindow.Windows.Add("Added Anchor Window", _
                           visWSVisible, visAnchorBarAddon, 1, 1, 400, 400)
  On Error GoTo 0
    
  If AncHostWindow Is Nothing Then
    MsgBox "Error adding anchor window: " + S, , "Error"
    GoTo done
  Else
    SetParent TheForm.HWnd, AncHostWindow.WindowHandle32
  End If
  JiggleWindow AncHostWindow.WindowHandle32
  TheForm.RefreshWinInfo
done:
End Function

'--------------------------------
Private Sub AncHostWindow_BeforeWindowClosed(ByVal Window As Visio.IVWindow)
'--------------------------------
  Set AncHostWindow = Nothing
  Unload fm_Anchored
End Sub

'--------------------------------------
Private Sub fm_Anchored_OnQueryUnload()
'--------------------------------------
  Set fm_Anchored = Nothing
End Sub

'=============================================================================
' Stencil Window
'=============================================================================

'---------------------------------
Private Function StenFormInit(ASessionId As Long) As Long
'---------------------------------
Dim AWindow As Visio.Window, S As String
Dim NewOwnerHWnd As Long, StyleBits As Long
Dim TheForm As Tfm_Stencil

  StenFormInit = vbvsl_SUCCESS ' default, if not going modeless
  If Not (fm_Stencil Is Nothing) Then GoTo done
  
  '------------------------------------
  ' Set up new form
  '------------------------------------
  Set fm_Stencil = New Tfm_Stencil
  fm_Stencil.Show False
  
  Set TheForm = fm_Stencil
  TheForm.SessionId = ASessionId
  StenFormInit = vbvsl_L2V_MODELESS

  Set StenHostWindow = Nothing
  On Error Resume Next
  Set StenHostWindow = glo.VisioApp.Windows.Add("Added Stencil Window", _
                   visWSVisible, visStencilAddon, 1, 1, 400, 399)
  On Error GoTo 0
  
  If StenHostWindow Is Nothing Then
    MsgBox "Error in VisioApp.Windows.Add", , "Error"
    GoTo done
  Else
    StyleBits = WS_CHILD Or WS_CLIPCHILDREN Or WS_CLIPSIBLINGS Or WS_VISIBLE
    SetWindowLong& TheForm.HWnd, GWL_Style, StyleBits
  
    SetParent TheForm.HWnd, StenHostWindow.WindowHandle32
    JiggleWindow StenHostWindow.WindowHandle32
  End If
no_win_change:
  TheForm.RefreshWinInfo
done:
End Function

'--------------------------------
Private Sub StenHostWindow_BeforeWindowClosed(ByVal Window As Visio.IVWindow)
'--------------------------------
  Set StenHostWindow = Nothing
  Unload fm_Stencil
End Sub

'--------------------------------------
Private Sub fm_Stencil_OnQueryUnload()
'--------------------------------------
  Set fm_Stencil = Nothing
End Sub


