VERSION 5.00
Object = "{F1A8DFE4-BC61-48BA-AFDA-96DF10247AF0}#1.0#0"; "VISOCX.DLL"
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   7215
   ClientLeft      =   165
   ClientTop       =   780
   ClientWidth     =   6825
   LinkTopic       =   "Form1"
   ScaleHeight     =   7215
   ScaleWidth      =   6825
   StartUpPosition =   3  'Windows Default
   Begin VisOcxCtl.DrawingControl VDC1 
      Height          =   6015
      Left            =   0
      TabIndex        =   0
      Top             =   720
      Width           =   6615
      HostID          =   "Generic_VDC_VB"
      NegotiateMenus  =   0   'False
      NegotiateToolbars=   0   'False
      PageSizingBehavior=   0
      Src             =   ""
   End
   Begin VB.CommandButton bt_TidyWindows 
      Caption         =   "Tidy Windows"
      Height          =   495
      Left            =   120
      TabIndex        =   3
      Top             =   120
      Width           =   975
   End
   Begin MSComDlg.CommonDialog dlg_SaveAs 
      Left            =   5040
      Top             =   120
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      DefaultExt      =   "vsd"
      DialogTitle     =   "Save As"
      Filter          =   "Visio files (*.vsd)|*.vsd|Visio XML (*.vdx)|*.vdx"
      FilterIndex     =   1
   End
   Begin MSComDlg.CommonDialog dlg_Open 
      Left            =   4200
      Top             =   120
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      DialogTitle     =   "Open Visio File"
      Filter          =   "Visio files (*.vsd)|*.vsd|Visio XML (*.vdx)|*.vdx"
      FilterIndex     =   1
   End
   Begin VB.CommandButton bt_RandomColors 
      Caption         =   "Random Colors"
      Height          =   495
      Left            =   2520
      TabIndex        =   2
      Top             =   120
      Width           =   975
   End
   Begin VB.CommandButton bt_OpenBasicShapes 
      Caption         =   "Open Basic Shapes"
      Height          =   495
      Left            =   1200
      TabIndex        =   1
      Top             =   120
      Width           =   1095
   End
   Begin VB.Menu mh_File 
      Caption         =   "&File"
      Begin VB.Menu mi_New 
         Caption         =   "&New (Reload Startup Doc)"
      End
      Begin VB.Menu mi_Clear 
         Caption         =   "&Clear Doc"
      End
      Begin VB.Menu mi_Open 
         Caption         =   "&Open..."
      End
      Begin VB.Menu mi_Save 
         Caption         =   "&Save..."
      End
      Begin VB.Menu mi_SaveAs 
         Caption         =   "Save &As..."
      End
      Begin VB.Menu mi_Quit 
         Caption         =   "&Quit"
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Const StartDocName = "MyStartDoc.vdx"
Dim HomeDir As String
Dim LastOpenedDoc As String

'----------------------
Private Sub Form_Load()
'----------------------
  HomeDir = App.Path
  dlg_Open.InitDir = HomeDir
  dlg_SaveAs.InitDir = HomeDir
  On Error GoTo ErrHandler
  Doc_ReloadStartupDoc
  Exit Sub
ErrHandler:
  MsgBox "Load Error: " & Err.Description
End Sub

'----------------------
Private Sub bt_OpenBasicShapes_Click()
'----------------------
Dim Msg As String
  On Error GoTo HandleError
  VDC1.Window.Application.Documents.OpenEx "Basic_U.vss", visOpenRO + visOpenDocked
  Exit Sub
HandleError:
  Msg = "bt_OpenBasicShapes_Click Error: " & Err.message
  MsgBox Msg
End Sub

'----------------------
Private Sub bt_RandomColors_Click()
'----------------------
Dim AShape As Visio.Shape, ACell As Visio.Cell
Dim RandColor As Integer
  For Each AShape In VDC1.Window.Application.ActivePage.Shapes
    RandColor = 15 * Rnd(1.2345)
    Set ACell = AShape.Cells("FillForegnd")
    ACell.ResultIU = RandColor
  Next AShape
 
End Sub

'----------------------
Private Sub Form_Resize()
'----------------------
  VDC1.Left = 0
  VDC1.Top = 720
  
  VDC1.Width = Form1.ScaleWidth
  VDC1.Height = Form1.ScaleHeight - 720
End Sub

'----------------------
Private Sub mi_Clear_Click()
'----------------------
Dim ADoc As Visio.Document, APage As Visio.Page
Dim PageIx1 As Integer, ShapeIx1 As Integer

  Set ADoc = VDC1.Document

  For PageIx1 = ADoc.Pages.Count To 2 Step -1
    ADoc.Pages(PageIx1).Delete (0)
  Next PageIx1

  Set APage = ADoc.Pages(1)

  For ShapeIx1 = APage.Shapes.Count To 1 Step -1
    APage.Shapes(ShapeIx1).Delete
  Next ShapeIx1
End Sub

'----------------------
Private Sub mi_New_Click()
'----------------------
  LastOpenedDoc = ""
  On Error GoTo ErrHandler
  Doc_ReloadStartupDoc
  Exit Sub
ErrHandler:
  MsgBox "New Error: " & Err.Description
End Sub

'---------------------------------
Private Sub Doc_ReloadStartupDoc()
'---------------------------------
Dim APath As String
  APath = HomeDir & "\" & StartDocName
  VDC1.Src = APath
  VDC1.Src = ""
  LastOpenedDoc = ""
End Sub

'---------------------------------
Private Sub mi_Open_Click()
'---------------------------------
Dim FilePath As String, Msg As String

  On Error GoTo HandleError
  dlg_Open.CancelError = True
  dlg_Open.ShowOpen
  FilePath = dlg_Open.FileName
  LastOpenedDoc = ""
  VDC1.Src = FilePath
  LastOpenedDoc = FilePath
  VDC1.Src = ""
  Exit Sub
  
HandleError:
  Msg = "mi_Open_Click" & Err.Description
  MsgBox Msg
End Sub

'---------------------------------
Private Sub mi_Save_Click()
'---------------------------------
Dim Msg As String
  If LastOpenedDoc <> "" Then
    On Error GoTo HandleError
    VDC1.Document.SaveAs LastOpenedDoc
  Else
    mi_SaveAs_Click
  End If
  Exit Sub
  
HandleError:
  Msg = "mi_Save_Click" & Err.message
  MsgBox Msg
End Sub

'---------------------------------
Private Sub mi_SaveAs_Click()
'---------------------------------
Dim FilePath As String, Msg As String

  On Error GoTo HandleError
  dlg_SaveAs.CancelError = True
  dlg_SaveAs.ShowSave
  
  FilePath = dlg_SaveAs.FileName
  VDC1.Document.SaveAs FilePath
  LastOpenedDoc = FilePath
  Exit Sub
  
HandleError:
  Msg = "mi_SaveAs_Click" & Err.message
  MsgBox Msg
End Sub

'---------------------------------
Private Sub mi_Quit_Click()
'---------------------------------
  End
End Sub

'---------------------------------
Private Sub bt_TidyWindows_Click()
'---------------------------------
  KillNonDrawingWindows Nothing
End Sub

'---------------------------------
Private Sub KillNonDrawingWindows(StartWin As Visio.Window)
'---------------------------------
Dim AWins As Visio.Windows, wintype As VisWinTypes
Dim AWin As Visio.Window

  If Not (StartWin Is Nothing) Then
    Set AWins = Nothing
    On Error Resume Next
    Set AWins = StartWin.Windows
    
    wintype = StartWin.Type
    
    Select Case wintype
      Case VisWinTypes.visDrawing:
        ' do nothing
      Case VisWinTypes.visDrawingAddon:
        ' do nothing
      Case VisWinTypes.visPageWin:
        ' do nothing
      Case VisWinTypes.visStencil:
        ' do nothing
      Case Visio.VisWinTypes.visDockedStencilBuiltIn:
        ' do nothing
      Case Else
        StartWin.Visible = False
        Set AWins = Nothing
    End Select
  Else
    Set AWins = VDC1.Document.Application.Windows
  End If

  If Not (AWins Is Nothing) Then
    For Each AWin In AWins
      KillNonDrawingWindows AWin
    Next AWin
  End If
End Sub

