VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "VBVSL_DSS_ConnCt"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Implements IVBVSL_AddOn

Const ServiceName = "ConnCt"
Const AddOnName = "VBVSL_DSS_" + ServiceName

'-----------------------------------------
' Service-specific command keywords
'-----------------------------------------

'-----------------------------------------
' Service-specific user row names
'-----------------------------------------
Const rn_ConnCt = "VDSS_ConnCt"
Const cn_ConnCt = "User." + rn_ConnCt

'-----------------------------------------
' Application WithEvents
'-----------------------------------------
Dim WithEvents VisioAppWithEvents As Visio.Application
Attribute VisioAppWithEvents.VB_VarHelpID = -1

'------------------------------
Private Sub Class_Initialize()
'------------------------------
' nothing
End Sub
'------------------------------
Private Sub Class_Terminate()
'------------------------------
' nothing
End Sub

'------------------------------------------------------------------------------------
Private Function IVBVSL_AddOn_AddOnInfo( _
        Attribs As VBVSL_Types.Tvbvsl_AddOnInfo_Attribs, _
        EnableMask As VBVSL_Types.Tvbvsl_AddOnInfo_EnableMask, _
        InvokeOnMask As VBVSL_Types.Tvbvsl_AddOnInfo_InvokeOnMask, _
        NotifyOnMask As VBVSL_Types.Tvbvsl_AddOnInfo_NotifyOnMask, _
        Name As String) As VBVSL_Types.Tvbvsl_ResultCodes
'------------------------------------------------------------------------------------
  Attribs = vbvsl_ATTS_ISACTION
  EnableMask = vbvsl_ENABLEALWAYS
  InvokeOnMask = vbvsl_INVOKE_DEFAULT
  NotifyOnMask = vbvsl_NOTIFY_DEFAULT
  Name = AddOnName
  
  IVBVSL_AddOn_AddOnInfo = vbvsl_SUCCESS
End Function

'------------------------------------------------------------------------------------
Private Function IVBVSL_AddOn_IsAddOnEnabled() As VBVSL_Types.Tvbvsl_ResultCodes
'------------------------------------------------------------------------------------
  IVBVSL_AddOn_IsAddOnEnabled = vbvsl_L2V_ENABLED
End Function

'------------------------------------------------------------------------------------
Private Sub IVBVSL_AddOn_KillSession(ByVal SessionId As Long)
'------------------------------------------------------------------------------------
  ' nothing
End Sub

'---------------------------------------------------------------------
Private Function IVBVSL_AddOn_Load() As VBVSL_Types.Tvbvsl_ResultCodes
'---------------------------------------------------------------------
  IVBVSL_AddOn_Load = vbvsl_SUCCESS
End Function

'------------------------------------------------------------------------------------
Private Function IVBVSL_AddOn_Run(ByVal SessionId As Long, ByVal ArgStr As String) As VBVSL_Types.Tvbvsl_ResultCodes
'------------------------------------------------------------------------------------
Dim Args As New VBVSL_ArgHandler, ADoc As Visio.Document, AShape As Visio.Shape
Dim Cmd As String

  IVBVSL_AddOn_Run = vbvsl_SUCCESS
  
  Args.ParseArgs UCase$(ArgStr)
  Cmd = Args.FindValue("cmd")
      
  Select Case UCase$(Cmd)
    Case kw_DocOpened, kw_DocCreated
      Set ADoc = DocFromArgs(Args)
      DocSubscriptionEnforce ADoc, ServiceName
      DocHookupCheck ADoc
     
    Case kw_ShapeDrop
      Set ADoc = DocFromArgs(Args)
      DocSubscriptionEnforce ADoc, ServiceName
      DocHookupCheck ADoc
      
      Set AShape = ShapeFromArgs(Args)
      ShapeSubscriptionEnforce AShape, ServiceName
      ShapeUpdateConnectCounts AShape
     
    Case kw_Beep
      Beep
      Beep
  End Select
End Function

'------------------------------------------------------------------------------------
Private Function IVBVSL_AddOn_Unload() As VBVSL_Types.Tvbvsl_ResultCodes
'------------------------------------------------------------------------------------
  ' free objects established by this addon
  Set VisioAppWithEvents = Nothing
  
  IVBVSL_AddOn_Unload = vbvsl_SUCCESS
End Function

'-----------------------------------------------------------
Private Sub DocHookupCheck(ADoc As Visio.Document)
'-----------------------------------------------------------
  '--------------------------------------------
  ' Standard persistent events to maintain our
  ' service over doc close-open
  '--------------------------------------------
  DocStdPersistentEvents ADoc, AddOnName

  '--------------------------------------------
  ' Any hookups custom for this service
  '--------------------------------------------
  If VisioAppWithEvents Is Nothing Then
    Set VisioAppWithEvents = glo.VisioApp
  End If
  
End Sub

'================================================
' The actual service itself
'================================================

'-----------------------------------------------------------
Private Sub VisioAppWithEvents_ConnectionsAdded(ByVal Connects As Visio.IVConnects)
'-----------------------------------------------------------
  UpdateConnectCounts Connects
End Sub

'-----------------------------------------------------------
Private Sub VisioAppWithEvents_ConnectionsDeleted(ByVal Connects As Visio.IVConnects)
'-----------------------------------------------------------
  UpdateConnectCounts Connects
End Sub

'-----------------------------------------------------------
Private Sub UpdateConnectCounts(ByVal Connects As Visio.IVConnects)
'-----------------------------------------------------------
' Recount each shape in the Connects list
Dim AConnect As Visio.Connect
  For Each AConnect In Connects
    ShapeUpdateConnectCounts AConnect.FromSheet
    ShapeUpdateConnectCounts AConnect.ToSheet
  Next AConnect
End Sub

'-----------------------------------------------------------
Private Sub ShapeUpdateConnectCounts(AShape As Visio.Shape)
'-----------------------------------------------------------
Dim ACell As Visio.Cell, Ct As Integer
' Check cell rn_SubscribedServices to see if this shape is eligible
' Add Shape cell rn_ConnCt if needed
' Count connections and stick result in rn_ConnCt cell

  On Error Resume Next
    Set ACell = AShape.CellsU(cn_SubscribedServices)
  On Error GoTo 0
  If Not (ACell Is Nothing) Then
    If StringInCell(ACell, ServiceName, False) Then
      ' since we're subscribed, add necessary cell if missing
      Set ACell = EnsureUserCellExists(AShape, rn_ConnCt)
      If Not (ACell Is Nothing) Then
        Ct = AShape.Connects.Count
        Ct = Ct + AShape.FromConnects.Count
        ACell.Formula = "=" + Format(Ct)
      End If
    End If
  End If

End Sub

