VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "VBVSL_DSS_NavKeys"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Implements IVBVSL_AddOn

Const ServiceName = "NavKeys"
Const AddOnName = "VBVSL_DSS_" + ServiceName

'-----------------------------------------
' Service-specific command keywords
'-----------------------------------------
Const kw_NavKey = "NAVKEY"

'-----------------------------------------
' Service-specific user row names
'-----------------------------------------
Const rn_NavKeys = "VDSS_NavKeys"
Const cn_NavKeys = "User." + rn_NavKeys

'-----------------------------------------
' Service-specific data
'-----------------------------------------

'------------------------------
Private Sub Class_Initialize()
'------------------------------
' nothing
End Sub
'------------------------------
Private Sub Class_Terminate()
'------------------------------
' nothing
End Sub

'------------------------------------------------------------------------------------
Private Function IVBVSL_AddOn_AddOnInfo( _
        Attribs As VBVSL_Types.Tvbvsl_AddOnInfo_Attribs, _
        EnableMask As VBVSL_Types.Tvbvsl_AddOnInfo_EnableMask, _
        InvokeOnMask As VBVSL_Types.Tvbvsl_AddOnInfo_InvokeOnMask, _
        NotifyOnMask As VBVSL_Types.Tvbvsl_AddOnInfo_NotifyOnMask, _
        Name As String) As VBVSL_Types.Tvbvsl_ResultCodes
'------------------------------------------------------------------------------------
  Attribs = vbvsl_ATTS_ISACTION
  EnableMask = vbvsl_ENABLEALWAYS
  InvokeOnMask = vbvsl_INVOKE_DEFAULT
  NotifyOnMask = vbvsl_NOTIFY_DEFAULT
  Name = AddOnName
  
  IVBVSL_AddOn_AddOnInfo = vbvsl_SUCCESS
End Function

'------------------------------------------------------------------------------------
Private Function IVBVSL_AddOn_IsAddOnEnabled() As VBVSL_Types.Tvbvsl_ResultCodes
'------------------------------------------------------------------------------------
  IVBVSL_AddOn_IsAddOnEnabled = vbvsl_L2V_ENABLED
End Function

'------------------------------------------------------------------------------------
Private Sub IVBVSL_AddOn_KillSession(ByVal SessionId As Long)
'------------------------------------------------------------------------------------
  ' nothing
End Sub

'---------------------------------------------------------------------
Private Function IVBVSL_AddOn_Load() As VBVSL_Types.Tvbvsl_ResultCodes
'---------------------------------------------------------------------
  IVBVSL_AddOn_Load = vbvsl_SUCCESS
End Function

'------------------------------------------------------------------------------------
Private Function IVBVSL_AddOn_Run(ByVal SessionId As Long, ByVal ArgStr As String) As VBVSL_Types.Tvbvsl_ResultCodes
'------------------------------------------------------------------------------------
Dim Args As New VBVSL_ArgHandler, ADoc As Visio.Document, AShape As Visio.Shape
Dim Cmd As String

  IVBVSL_AddOn_Run = vbvsl_SUCCESS
  
  Args.ParseArgs UCase$(ArgStr)
  Cmd = Args.FindValue("cmd")
      
  Select Case UCase$(Cmd)
  
    Case kw_DocOpened, kw_DocCreated
      Set ADoc = DocFromArgs(Args)
      DocSubscriptionEnforce ADoc, ServiceName
      DocHookupCheck ADoc
     
    Case kw_ShapeDrop
      Set ADoc = DocFromArgs(Args)
      
      ' In this sample, don't redo subscription and hookup
      ' if already subscribed
      If Not IsSubscribed(ADoc.DocumentSheet, ServiceName) Then
        DocSubscriptionEnforce ADoc, ServiceName
        DocHookupCheck ADoc
      End If
      
      Set AShape = ShapeFromArgs(Args)
      ShapeSubscriptionEnforce AShape, ServiceName
      
    Case kw_NavKey
      HandleNavKey Args
     
    Case kw_Beep
      Beep
      Beep
  End Select
End Function

'------------------------------------------------------------------------------------
Private Function IVBVSL_AddOn_Unload() As VBVSL_Types.Tvbvsl_ResultCodes
'------------------------------------------------------------------------------------
  ' free objects established by this addon
  
  IVBVSL_AddOn_Unload = vbvsl_SUCCESS
End Function

'-----------------------------------------------------------
Private Sub DocHookupCheck(ADoc As Visio.Document)
'-----------------------------------------------------------
Dim UI As Visio.UIObject
Dim AAccelItems As Visio.AccelItems, AAccelItem As Visio.AccelItem
Dim AccelIx As Integer, KIIx As Integer
Dim AddOnArgs As String, S As String
Const OurUIName = "WithNav"
  '--------------------------------------------
  ' Standard persistent events to maintain our
  ' service over doc close-open
  '--------------------------------------------
  DocStdPersistentEvents ADoc, AddOnName

  '--------------------------------------------
  ' Any hookups custom for this service
  '--------------------------------------------
  ' Fixup Accelerators to notify us on Nav Keys
  ' 1. Retrieve appropriate UI to fixup
  On Error Resume Next
    Set UI = ADoc.CustomMenus
    If Not (UI Is Nothing) Then
      Set UI = UI.Clone
    Else
      Set UI = glo.VisioApp.CustomMenus
      If (Not UI Is Nothing) Then
        Set UI = UI.Clone
      Else
        Set UI = glo.VisioApp.BuiltInMenus ' gets a clone
      End If
    End If
  On Error GoTo 0
  
  '---------------------------------------------------
  ' Rudely discard any existing competing accelerators
  '---------------------------------------------------
  InitKeyInfos
  If UI Is Nothing Then GoTo skipit
  On Error Resume Next
    Set AAccelItems = UI.AccelTables.ItemAtID(visUIObjSetDrawing).AccelItems
    If Not (AAccelItems Is Nothing) Then ' Delete previous accelerators
      For AccelIx = AAccelItems.Count - 1 To 0 Step -1
        Set AAccelItem = AAccelItems(AccelIx)
        For KIIx = 1 To KeyInfoCount
          If (AAccelItem.Key = KeyInfos(KIIx).Key) And _
             (AAccelItem.Alt = KeyInfos(KIIx).Alt) And _
             (AAccelItem.Control = KeyInfos(KIIx).Ctl) And _
             (AAccelItem.Shift = KeyInfos(KIIx).Shf) Then
            AAccelItem.Delete
            GoTo next_accel
          End If
        Next KIIx
next_accel:
      Next AccelIx
    End If
  On Error GoTo 0
  
  '----------------------------------------------------
  ' Add our accelerators
  '----------------------------------------------------
  For KIIx = 1 To KeyInfoCount
    AddOnArgs = "Cmd=" + kw_NavKey + " " + KeyInfos(KIIx).Args
    Set AAccelItem = AAccelItems.Add
    AAccelItem.Key = KeyInfos(KIIx).Key
    AAccelItem.Alt = KeyInfos(KIIx).Alt
    AAccelItem.Control = KeyInfos(KIIx).Ctl
    AAccelItem.Shift = KeyInfos(KIIx).Shf
    AAccelItem.AddOnName = AddOnName
    AAccelItem.AddOnArgs = AddOnArgs
  Next KIIx
  
  '----------------------------------------------------
  ' Instate our UIObject, somewhat brute-force
  '----------------------------------------------------
  S = UI.Name
  S = Right$(S, Len(OurUIName))
  If S <> OurUIName Then UI.Name = UI.Name + " " + OurUIName
  ADoc.ClearCustomMenus
  ADoc.SetCustomMenus UI
  ADoc.CustomMenus.UpdateUI
skipit:
End Sub

'================================================
' The actual service itself
'================================================

'-----------------------------------------------------------
Private Sub HandleNavKey(Args As VBVSL_ArgHandler)
'-----------------------------------------------------------
Dim ASel As Visio.Selection, AShape As Visio.Shape
Dim OtherShape As Visio.Shape
Dim ParentShape As Visio.Shape, APage As Visio.Page
Dim ShapeIx As Integer
Dim StartIx As Integer, EndIx As Integer, AStep As Integer
Dim N As Integer, Dirn As String

  Dirn = UCase$(Args.FindValue("DIRN"))

  On Error Resume Next

  Set ASel = glo.VisioApp.ActiveWindow.Selection
  If ASel Is Nothing Then GoTo skipit
  If ASel.Count = 0 Then ASel.IterationMode = visSelModeOnlySub ' member shape
  If ASel.Count <> 1 Then GoTo skipit
  Set AShape = ASel(1)
  If AShape Is Nothing Then GoTo skipit
  
  Set ParentShape = AShape.ContainingShape ' will be PageSheet if AShape is at top level
  Select Case Dirn
    Case "DOWN"
      AStep = 1
      EndIx = ParentShape.Shapes.Count
    Case Else
      AStep = -1
      EndIx = 1
  End Select
  
  StartIx = AShape.Index + AStep
  For N = 1 To 2
    For ShapeIx = StartIx To EndIx Step AStep
      Set OtherShape = Nothing
      Set OtherShape = ParentShape.Shapes(ShapeIx)
      If IsSubscribed(OtherShape, ServiceName) Then GoTo foundit
    Next ShapeIx
    
    Select Case Dirn
      Case "DOWN"
        StartIx = 1
      Case Else
        StartIx = ParentShape.Shapes.Count
    End Select
    EndIx = AShape.Index
  Next N
  
foundit:
  If OtherShape Is Nothing Then GoTo skipit
  
  SelectAnyShape OtherShape
  glo.VisioApp.DoCmd visCmdTextEditState
skipit:
End Sub

'-----------------------------------------------------------
Private Sub SelectAnyShape(AShape As Visio.Shape)
'-----------------------------------------------------------
' deals with problem of not able to select member shape directly
Dim Group As Visio.Shape

  Set Group = AShape.ContainingShape
  If Group.Id = 0 Then               ' AShape is in Page
    glo.VisioApp.ActiveWindow.DeselectAll
    glo.VisioApp.ActiveWindow.Select AShape, visSelect
  Else
    SelectAnyShape Group  ' iterate up so can dig down on way back
    glo.VisioApp.ActiveWindow.Select AShape, visSubSelect
  End If
End Sub
